unit IgnorDlg;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Grids, ListDir;

type

  { TIgnoreDlg }

  TIgnoreDlg = class(TForm)
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    procedure CheckBox1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    Procedure FrontPage;
    procedure Memo1Change(Sender: TObject);
  private
    { private declarations }
    FIgnoreArray : TStrArray;
    FChanged: Boolean;
  public
    { public declarations }
    property changed: boolean read FChanged;
    property IgnoreArray: TStrArray read FIgnoreArray write FIgnoreArray;
  end; 

var
  IgnoreDlg: TIgnoreDlg;
  FTPIgnoreDlg: TIgnoreDlg;
  FirstShow: Boolean;
implementation

{ TIgnoreDlg }


procedure TIgnoreDlg.CheckBox1Change(Sender: TObject);
begin
  FrontPage;
end;

procedure TIgnoreDlg.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var
  i: integer;
begin
  setlength(IgnoreArray, Memo1.Lines.Count);
  for i:= 0 to high(FIgnoreArray) do begin
    FIgnoreArray[i]:= Memo1.Lines[i];
  end;
end;

procedure TIgnoreDlg.FormCreate(Sender: TObject);
begin
  FirstShow:= true;
end;

procedure TIgnoreDlg.FormShow(Sender: TObject);
var
  i: integer;
begin
  FChanged:= False;
  Memo1.Lines.Clear;
  for i:= 0 to high(IgnoreArray) do begin
    Memo1.Lines.Add(IgnoreArray[i]);
  end;
end;

procedure TIgnoreDlg.FrontPage;
var
  i: integer;
begin
  if CheckBox1.Checked then begin
    Memo1.Lines.Add('_Private');
    Memo1.Lines.Add('_vti_cnv');
    Memo1.Lines.Add('_vti_pvt');
    Memo1.Lines.Add('_vti_cnf');
  end else begin
    for i:= 0 to Memo1.Lines.Count-1 do begin;
      if Memo1.Lines[i] = '_Private' then Memo1.Lines.Delete(i);
      if Memo1.Lines[i] = '_vti_cnv' then Memo1.Lines.Delete(i);
      if Memo1.Lines[i] = '_vti_pvt' then Memo1.Lines.Delete(i);
      if Memo1.Lines[i] = '_vti_cnf' then Memo1.Lines.Delete(i);
    end;
  end;
end;

procedure TIgnoreDlg.Memo1Change(Sender: TObject);
begin
  FChanged:= true;
end;

initialization
  {$I IgnorDlg.lrs}

end.

