unit LFTPUnit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  FTPSend, ListDir, MD5, Grids, ExtDlgs, ExtCtrls, IniFiles, UsrDialog, IgnorDlg,
  ComCtrls, myftpdirdialog;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button11: TButton;
    Button12: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    UpDateBox: TCheckBox;
    LoadBox: TCheckBox;
    DelBox: TCheckBox;
    NoneBox: TCheckBox;
    ComboBox1: TComboBox;
    DelLabel: TLabel;
    DirEdit: TEdit;
    DirFLabel: TLabel;
    DirLLabel: TLabel;
    FileFLabel: TLabel;
    FileLLabel: TLabel;
    FTPDirEdit: TEdit;
    IPEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    CompLabel: TLabel;
    Panel12: TPanel;
    ProgressLabel: TLabel;
    LoadLabel: TLabel;
    NameEdit: TEdit;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    ProgressPanel: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    PassEdit: TEdit;
    PortEdit: TEdit;
    ProgressBar1: TProgressBar;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    StringGrid1: TStringGrid;
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ActionChange(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure CheckBox3Change(Sender: TObject);
    procedure CheckBox4Change(Sender: TObject);
    procedure CheckBox5Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure DirEditChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure DoCompare;
    procedure FTPDirEditChange(Sender: TObject);
    procedure ShowDLG;
    procedure StringGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
  private
    { private declarations }
    procedure progevent(pos: Integer; filename: AnsiString);
    procedure localevent(count: integer; filename: AnsiString);
    procedure ftpevent(count: integer; filename: AnsiString);
    procedure compevent(pos: integer; filename: AnsiString);
    procedure localerrorevent(value: AnsiString);
    procedure clearall;
    procedure saveini;
    procedure BuildGrid;
  public
    { public declarations }
  end; 
  
const
  ActionStrings : array [0..3] of string = ('load', 'update', 'delete', 'OK');

var
  Form1: TForm1; 
  AFTPSend: TFTPSend;
  DList: TListDir;
  Ini: TIniFile;
  LocalIni: TIniFile;
  LocalIniName: String;
  FirstActivate: boolean;
  SaveName: string;
  Konf: string;
  DirLCount: integer;
  DirFCount: integer;
  CompCount: integer;
  IgnoreArray: TStrArray;
  LocIgnoreArray: TStrArray;
  FTPIgnoreArray: TStrArray;
  

implementation
function StringToCaseSelect (Selector: string; CaseList: array of string): integer;
var
  cnt: integer;
begin
  result:= -1;
  for cnt:= 0 to high(CaseList) do begin
    if CompareText(Selector, CaseList[cnt]) = 0 then begin
      result:= cnt;
      break;
    end;
  end;
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  FirstActivate:= true;
  {$ifdef unix}
    combobox1.ItemIndex:= 1;
  {$else}
    combobox1.ItemIndex:= 0;
  {$endif}
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  StringGrid1.ColWidths[0]:= StringGrid1.Width-(StringGrid1.DefaultColWidth*(StringGrid1.ColCount-1))-25;
  ProgressPanel.Left:= StringGrid1.Left+1;
  ProgressPanel.Top:= (StringGrid1.Height div 2);
  ProgressPanel.Width:= StringGrid1.Width-2;
end;

procedure TForm1.DoCompare;
var
  tmpl,tmpf: TStrings;
  i: integer;
  casetmp: TFTPError;
  s: string;
begin
  StringGrid1.RowCount:= 1;
  DList.Abort:= false;
  tmpl:= TStringlist.Create;
  tmpf:= TStringList.Create;
  DList.username:= NameEdit.Text;
  DList.PassWord:= PassEdit.Text;
  DList.Host:= IPEdit.Text;
  DList.Port:= PortEdit.Text;
  if not DirectoryExists(DirEdit.Text) then begin
    ShowMessage('Directory not found: ' + DirEdit.Text);
    exit;
   end else begin
    Panel6.Caption:= 'Search Local';
    Panel6.Color:= clBlue;
    Application.ProcessMessages;
    if not DList.CallDirFiles(DirEdit.Text, tmpl) then begin
      Panel6.Caption:= 'Error';
      Panel6.Color:= clRed;
      exit;
    end;
  end;
  Panel6.Caption:= 'Search FTP';
  Panel6.Color:= clGreen;
  Application.ProcessMessages;
  s:= FTPDirEdit.Text;
//  while (length(s) > 0)  do begin
//    if (s[1] = '/') or (s[1] = '~') then begin
//      delete(s, 1, 1);
//    end else break;
//  end;
  casetmp:= DList.CallFTPFiles(s, tmpf, CheckBox1.Checked);
  case casetmp of
    feNotConnected: begin
      ShowMessage('FTP not connected');
      Panel6.Caption:= 'Error';
      Panel6.Color:= clRed;
      exit;
    end;
    feDirNotFound: begin
      ShowMessage('FTP dir not found: ' + FTPDirEdit.Text);
      Panel6.Caption:= 'Error';
      Panel6.Color:= clRed;
      exit
    end;
    feCouldNotCreate: begin
      ShowMessage('FTP could not create: ' + FTPDirEdit.Text);
      Panel6.Caption:= 'Error';
      Panel6.Color:= clRed;
      exit
    end;
  end;
  Panel6.Caption:= 'Comparing';
  panel6.Color:= clRed;
  Application.ProcessMessages;
  DList.CompareDirFiles;
  DirLLabel.Caption:= 'Dirs Local: ' + IntToStr(DList.DirectoriesLocal);
  FileLLabel.Caption:= 'Files Local: ' + IntToStr(DList.FilesLocal);
  DirFLabel.Caption:= 'Dirs FTP: ' + IntToStr(DList.DirectoriesFTP);
  FileFlabel.Caption:= 'Files FTP: ' + IntToStr(DList.FilesFTP);
  LoadLabel.Caption:= 'Load: ' + IntToStr(DList.LoadFiles);
  DelLabel.Caption:= 'Del: ' + IntToStr(DList.DelFiles);
  StringGrid1.FixedCols:= 0;
  StringGrid1.FixedRows:= 1;
{  StringGrid1.RowCount:= DList.ResultList.Count+1;
  for i := 0 to DList.ResultList.Count - 1 do begin
    StringGrid1.Cells[0,i+1]:= (DList.ResultList[i]as TFileListItem).name;
    StringGrid1.Cells[1,i+1]:= (DList.ResultList[i]as TFileListItem).size;
 //   StringGrid1.Cells[2,i+1]:= DateTimeToStr(FileDateToDateTime(StrToInt64((DList.ResultList[i]as TFileListItem).time)));
    if (DList.ResultList[i]as TFileListItem).Localtime <> 0 then
      StringGrid1.Cells[2,i+1]:= DateTimeToStr((DList.ResultList[i]as TFileListItem).Localtime)
     else
      StringGrid1.Cells[2,i+1]:= '-';
    if (DList.ResultList[i]as TFileListItem).FTPtime <> 0 then
      StringGrid1.Cells[3,i+1]:= DateTimeToStr((DList.ResultList[i]as TFileListItem).FTPtime)
     else
      StringGrid1.Cells[3,i+1]:= '-';
    if (DList.ResultList[i]as TFileListItem).Upload.load then
      StringGrid1.Cells[4,i+1]:= 'load'
     else if (DList.ResultList[i]as TFileListItem).UpLoad.overwrite then
      StringGrid1.Cells[4,i+1]:= 'update'
     else if (DList.ResultList[i]as TFileListItem).del then
      StringGrid1.Cells[4,i+1]:= 'del'
     else StringGrid1.Cells[4,i+1]:= 'none'
  end;   }
  BuildGrid;
  CompLabel.Caption:= 'Compared: ' + IntToStr(DList.Compared);
  Panel6.Caption:= 'Idle';
  Panel6.color:= clLime;
  Application.ProcessMessages;
  button12.Enabled:= not DList.Abort;
end;

procedure TForm1.FTPDirEditChange(Sender: TObject);
begin
  Button12.Enabled:= false;
end;


procedure TForm1.ShowDLG;
begin
  SetLength(IgnoreArray, 0);
  UserDialog.IniFileName:= LocalIniName;
  UserDialog.Konf:= Konf;
  UserDialog.ShowModal;
  SaveName:= UserDialog.Name;
  IPEdit.Text:= UserDialog.Host;
  PortEdit.Text:= UserDialog.Port;
  NameEdit.Text:= UserDialog.User;
  PassEdit.Text:= UserDialog.Pass;
  DirEdit.Text:= UserDialog.LDir;
  FTPDirEdit.Text:= UserDialog.FDir;
  CheckBox2.Checked:= UserDialog.Igno;
  CheckBox3.Checked:= UserDialog.WriteLog;
  CheckBox4.Checked:= UserDialog.JustMD5;
  CheckBox5.Checked:= UserDialog.Passive;
  LocIgnoreArray:= copy(UserDialog.IgnoreArray);
  FTPIgnoreArray:= copy(UserDialog.FTPIgnoreArray);
  UserDialog.hide;
  Caption:= 'FTPCompare'+ ' - ' + LocalIniName + ' / ' + SaveName;
  IgnoreDlg.CheckBox1.Checked:= UserDialog.FPage;
end;

procedure TForm1.StringGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
var
  celltext: string;
begin
  with (Sender as TStringGrid) do
  begin
    celltext := Cells[ACol, ARow];
//    SetBkMode(Canvas.Handle, OPAQUE);
    case StringToCaseSelect(celltext, ActionStrings) of
      0,1: Canvas.Brush.Color := clLime;
      2: Canvas.Brush.Color := clRed;
      3: Canvas.Brush.Color := clGray;
    end;
    Canvas.FillRect(aRect);
//    SetBkMode(StringGrid1.Canvas.Handle, TRANSPARENT); // Den Hintergrund nich berschreiben
//    DrawText(Canvas.Handle, PChar(celltext), Length(celltext),Rect, DT_SINGLELINE);
  end;
end;

procedure TForm1.Button11Click(Sender: TObject);
var
  i: integer;
  hi: integer;
begin
  clearall;
  IgnoreArray:= copy(LocIgnoreArray);
  SetLength(IgnoreArray, Length(IgnoreArray)+Length(FTPIgnoreArray));
  hi:= high(LocIgnoreArray)+1;
  for i:= hi to High(IgnoreArray) do begin
    IgnoreArray[i]:= FTPIgnoreArray[i-hi];
  end;
  Button1.Enabled:= false;
  Button11.Enabled:= false;
  Button12.Enabled:= false;
  CheckBox1.Enabled:= false;
  Dlist.LocalListEvent:= @localevent;
  DList.FTPListEvent:= @ftpevent;
  DList.CompareEvent:= @compevent;
  DList.ErrorEvent:= @localerrorevent;
  DList.IgnoreArray:= IgnoreArray;
  DList.FTPIgnoreArray:= FTPIgnoreArray;
  DList.Abort:= false;
  DList.Ignore:= CheckBox2.Checked;
  DList.md5FTP:=CheckBox4.Checked;
  progressbar1.Position:= 0;
  progresslabel.Caption:='';
  ProgressPanel.Show;
  docompare;
  ProgressPanel.Hide;
  CheckBox1.Checked:= false;
  Button1.Enabled:= true;
  Button11.Enabled:= true;
  CheckBox1.Enabled:= true;
  saveini;
end;

procedure TForm1.progevent(pos: Integer; filename: AnsiString);
var  n: Integer;
begin
  n := pos * 100 div ProgressBar1.Max;
  progressbar1.Position:= pos;
  progresslabel.Caption:= inttostr(n) + '%   file: ' + filename;
  Application.ProcessMessages;
end;

procedure TForm1.localevent(count: integer; filename: AnsiString);
begin
  if DirLCount > 14 then begin
    FileLLabel.Caption:= 'Files Local: ' + IntToStr(count);
    Application.ProcessMessages;
    DirLCount:= 0;
   end else begin
    inc(DirLCount);
  end;
end;

procedure TForm1.ftpevent(count: integer; filename: AnsiString);
begin
  if DirFCount > 14 then begin
    FileFLabel.Caption:= 'Files FTP: ' + IntToStr(count);
    Application.ProcessMessages;
    DirFCount:= 0;
   end else begin
    inc(DirFCount);
  end
end;

procedure TForm1.compevent(pos: integer; filename: AnsiString);
const
  frequency= 1;
var
  n: integer ;
begin
  inc(CompCount);
  if CompCount >= frequency then begin
    CompLabel.Caption:= 'Compared: ' + IntToStr(pos);

    if DList.FilesLocal > 0 then begin
      progressbar1.Max:=DList.FilesLocal;
     end else begin
      progressbar1.Max:=1;
    end;
    progressbar1.Position:= pos;
    n := pos * 100 div ProgressBar1.Max;
    progresslabel.Caption:= inttostr(n) + '%   file: ' + filename;

    LoadLabel.Caption:= 'Load: ' + IntToStr(DList.LoadFiles);
    DelLabel.Caption:= 'Del: ' + IntToStr(DList.DelFiles);
    DirLLabel.Caption:= 'Dirs Local: ' + IntToStr(DList.DirectoriesLocal);
    FileLLabel.Caption:= 'Files Local: ' + IntToStr(DList.FilesLocal);
    DirFLabel.Caption:= 'Dirs FTP: ' + IntToStr(DList.DirectoriesFTP);
    FileFlabel.Caption:= 'Files FTP: ' + IntToStr(DList.FilesFTP);

    Application.ProcessMessages;
    CompCount:= 0;
  end;
end;

procedure TForm1.localerrorevent(value: AnsiString);
begin
  ShowMessage(value);
end;

procedure TForm1.clearall;
begin
  SetLength(IgnoreArray, 0);
  DirLCount:= 0;
  DirFCount:= 0;
  CompCount:= 0;
  CompLabel.Caption:= 'Compared: ';
  LoadLabel.Caption:= 'Load: ';
  DelLabel.Caption:= 'Del: ';
  DirLLabel.Caption:= 'Dirs Local: ';
  DirFLabel.Caption:= 'Dirs FTP: ';
  FileLLabel.Caption:= 'Files Local: ';
  FileFLabel.Caption:= 'Files FTP: ';
end;

procedure TForm1.saveini;
var
  i: integer;
begin
  if LocalIniName <> LocalIni.ReadString('IniFile', 'Path', '') then
    LocalIni.WriteString('IniFile', 'Path', LocalIniName);
  if Konf <> LocalIni.ReadString('IniFile', 'Konfig', '') then
    LocalIni.WriteString('IniFile', 'Konfig', Konf);
//  if CheckBox3.Checked <> LocalIni.ReadBool('IniFile', 'Log', false) then
//    LocalIni.WriteBool('IniFile', 'Log', CheckBox3.Checked);
  ini:= TIniFile.create(LocalIniName);
  ini.WriteString(SaveName, 'Name', SaveName);
  ini.WriteString(SaveName, 'Host', IPEdit.Text);
  ini.WriteString(SaveName, 'Port', PortEdit.Text);
  ini.WriteString(SaveName, 'User', NameEdit.Text);
  ini.WriteString(SaveName, 'DirL'+Konf, DirEdit.Text);
  ini.WriteString(SaveName, 'DirF', FTPDirEdit.Text);
  ini.WriteString(SaveName, 'Pass', PassEdit.Text);
  ini.WriteBool(SaveName, 'Ign', CheckBox2.Checked);
  ini.WriteBool(SaveName, 'FPage', IgnoreDlg.CheckBox1.Checked);
  ini.WriteBool(SaveName, 'Passive', CheckBox5.Checked);
  ini.WriteBool('All', 'Log', CheckBox3.Checked);
  ini.WriteBool('All', 'MD5', CheckBox4.Checked);
  ini.EraseSection('Ignore');
  ini.EraseSection('FTPIgnore');
  for i:= 0 to high(LocIgnoreArray) do begin
    Ini.WriteString('Ignore', inttostr(i+1), LocIgnoreArray[i]);
  end;
  for i:= 0 to high(FTPIgnoreArray) do begin
    Ini.WriteString('FTPIgnore', inttostr(i+1), FTPIgnoreArray[i]);
  end;
  ini.free;
end;

procedure TForm1.BuildGrid;
var
  i,j: integer;
  x: integer;
begin
{  for i:= 0 to StringGrid1.ColCount - 1 do begin
    for j:= 1 to StringGrid1.RowCount - 1 do begin
      StringGrid1.Cells[i,j]:= '';
    end;
  end;  }
  StringGrid1.RowCount:= 1;
  j:= 0;
  for i:= 0 to DList.ResultList.Count - 1 do begin
    x:= 0;
    if NoneBox.Checked then begin
      x:= 4;
    end;
    if (DList.ResultList[i]as TFileListItem).Upload.load then begin
      if LoadBox.Checked then begin
        x:= 1;
       end else begin
        x:= 0;
      end;
     end else begin
      if (DList.ResultList[i]as TFileListItem).Upload.overwrite then begin
        if UpDateBox.Checked then begin
          x:= 2;
         end else begin
          x:= 0;
        end;
       end else begin
        if (DList.ResultList[i]as TFileListItem).del then begin
          if DelBox.Checked then begin
            x:= 3;
           end else begin
            x:= 0;
          end;
        end;
      end;
    end;

    if x > 0 then begin
      StringGrid1.RowCount:= StringGrid1.RowCount+1;
      inc(j);
    end;
    case x of
      0: continue;
      1: StringGrid1.Cells[4,j]:= ActionStrings[x-1];
      2: StringGrid1.Cells[4,j]:= ActionStrings[x-1];
      3: StringGrid1.Cells[4,j]:= ActionStrings[x-1];
      4: StringGrid1.Cells[4,j]:= ActionStrings[x-1];
    end;
    StringGrid1.Cells[0,j]:= (DList.ResultList[i]as TFileListItem).name;
    StringGrid1.Cells[1,j]:= (DList.ResultList[i]as TFileListItem).size;
    if (DList.ResultList[i]as TFileListItem).Localtime <> 0 then
      StringGrid1.Cells[2,j]:= DateTimeToStr((DList.ResultList[i]as TFileListItem).Localtime)
     else
      StringGrid1.Cells[2,j]:= '-';
    if (DList.ResultList[i]as TFileListItem).FTPtime <> 0 then
      StringGrid1.Cells[3,j]:= DateTimeToStr((DList.ResultList[i]as TFileListItem).FTPtime)
     else
      StringGrid1.Cells[3,j]:= '-';
  end;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  Panel6.Color:= clGreen;
  Panel6.Caption:= 'Load/Del';
  DList.Abort:= false;
  progressbar1.Position:= 0;
  progresslabel.Caption:='';
  if DList.LoadFiles > 0 then begin
    ProgressBar1.Max:= DList.LoadFiles;
   end else begin
    ProgressBar1.Max:= 1;
  end;
  ProgressPanel.Show;
//  ProgressBar1.Show;
  DList.ProgressEvent:= @progevent;
  Dlist.commit;
  ProgressPanel.Hide;
  DoCompare;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then LocalIniName:= OpenDialog1.FileName;
  ShowDLG;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SelectDirectoryDialog1.FileName:= DirEdit.Text;
  if SelectDirectoryDialog1.Execute then begin
    DirEdit.Text:= SelectDirectoryDialog1.FileName;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  DList.Abort:= true;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  saveini;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  ShowDLG;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  IgnoreDlg.IgnoreArray:= LocIgnoreArray;
  IgnoreDlg.ShowModal;
  LocIgnoreArray:= copy(IgnoreDlg.IgnoreArray);
  Button12.Enabled:= false;
end;

procedure TForm1.ActionChange(Sender: TObject);
begin
  BuildGrid;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  tmps: string;
begin
  Button12.Enabled:= false;
 // dialog:= TFTPDirectoryDialog.create(self);
  FTPDirectoryDialog.Host:= IPEdit.Text;
  FTPDirectoryDialog.Port:= PortEdit.text;
  FTPDirectoryDialog.User:= NameEdit.text;
  FTPDirectoryDialog.Pass:= PassEdit.text;
  FTPDirectoryDialog.Showmodal;
  tmps:= FTPDirectoryDialog.Path;
  if tmps <> '' then
    FTPDirEdit.Text:= tmps
   else
    FTPDirEdit.Text:= '.';
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  FTPIgnoreDlg.IgnoreArray:= FTPIgnoreArray;
  FTPIgnoreDlg.ShowModal;
  FTPIgnoreArray:= copy(FTPIgnoreDlg.IgnoreArray);
  Button12.Enabled:= false;
end;

procedure TForm1.CheckBox3Change(Sender: TObject);
begin
  DList.WriteLog:= CheckBox3.Checked;
end;

procedure TForm1.CheckBox4Change(Sender: TObject);
begin
  DList.md5FTP:= CheckBox4.Checked;
end;

procedure TForm1.CheckBox5Change(Sender: TObject);
begin
  DList.Passive:= CheckBox5.Checked;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  Konf:= inttostr(ComboBox1.ItemIndex + 1);
  ShowDLG;
end;

procedure TForm1.DirEditChange(Sender: TObject);
begin
  button12.Enabled:= false;
end;

procedure TForm1.FormActivate(Sender: TObject);
var
  tmpl: TStringList;
  i: integer;
begin
  if FirstActivate then begin
    DList:= TListDir.create;
    tmpl:= TStringList.create;
    FirstActivate:= false;
    FTPIgnoreDlg.CheckBox1.free;
    LocalIni:= TIniFile.Create(ChangeFileExt(Application.ExeName, '_Dir.ini'));
    LocalIniName:= LocalIni.ReadString('IniFile', 'Path', '');
    Konf:= LocalIni.ReadString('IniFile', 'Konfig', '0');
    ShowDLG;
    DList.WriteLog:= CheckBox3.Checked;
    DList.Passive:= CheckBox5.Checked;
    Localini.ReadSection('Ignore', tmpl);
    if LocalIniName = '' then begin
      if OpenDialog1.Execute then LocalIniName:= OpenDialog1.FileName;
    end;
    AFTPSend:= TFTPSend.Create;
    AFTPSend.Timeout:= 10000;
    AFTPSend.DirectFile:= false;

    DList.LogFileName:= IncludeTrailingPathDelimiter(ExtractFileDir(LocalIniName))+ 'FTPLog.txt';
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  saveini;
end;

initialization
  {$I LFTPUnit.lrs}

end.

