unit UsrDialog;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Grids,
  StdCtrls, IniFiles, ExtCtrls;

type
  TIgnoreStr = Array of AnsiString;

  { TUserDialog }

  TUserDialog = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure StringGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    NameList: TStrings;
    IniFile: TIniFile;
    passes: array of string;

    FName: string;
    FHost: string;
    FPort: string;
    FUser: string;
    FPass: string;
    FLDir: string;
    FFDir: string;
    FKonf: string;
    FIgno: boolean;
    FFpage: boolean;
    FPassive: boolean;
    FWriteLog: boolean;
    FJustMD5: boolean;
    FIniFileName: string;
    FIgnoreArray: TIgnoreStr;
    FFTPIgnoreArray: TIgnoreStr;
    { private declarations }
    procedure UseSelected;
    procedure buildgrid;
  public
    { public declarations }
    
    property Name: string read FName;
    property Host: string read FHost;
    property Port: string read FPort;
    property User: string read FUser;
    property Pass: string read FPass;
    property LDir: string read FLDir;
    property FDir: string read FFDir;
    property Konf: string read FKonf write FKonF;
    property Igno: boolean read FIgno write FIgno;
    property FPage: boolean read FFPage;
    property Passive: boolean read FPassive;
    property WriteLog: boolean read FWRiteLog;
    property JustMD5: boolean read FJustMD5;
    property IniFileName: string read FIniFileName write FIniFileName;
    property IgnoreArray: TIgnoreStr read FIgnoreArray;
    property FTPIgnoreArray: TIgnoreStr read FFTPIgnoreArray;
  end; 

var
  UserDialog: TUserDialog;
  

implementation

{ TUserDialog }

procedure TUserDialog.FormShow(Sender: TObject);
begin
  Inifile:= TIniFile.Create(FIniFileName);
  buildgrid;
  iniFile.free;
end;


procedure TUserDialog.StringGrid1DblClick(Sender: TObject);
begin
  UseSelected;
end;

procedure TUserDialog.StringGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = $2E then Button3Click(nil);
end;

procedure TUserDialog.UseSelected;
var
  i: integer;
begin
  i:= StringGrid1.row;
  if i > 0 then begin
    FName:= StringGrid1.cells[0,i];
    FHost:= StringGrid1.cells[1,i];
    FPort:= StringGrid1.cells[2,i];
    FUser:= StringGrid1.cells[3,i];
    FLDir:= StringGrid1.cells[4,i];
    FFDir:= StringGrid1.cells[5,i];
    FIgno:= StrToBool(StringGrid1.cells[6,i]);
    FFpage:= StrToBool(StringGrid1.cells[7,i]);
    FPassive:= StrToBool(StringGrid1.cells[8,i]);
    FPass:= passes[i-1];
  end;
  UserDialog.ModalResult:= 1;
end;

procedure TUserDialog.buildgrid;
var
  i: integer;
  p: integer;
  x: integer;
//  sec: TStrings;
begin
  NameList:= TStringlist.create;
  IniFile.ReadSections(NameList);
//  sec:= TStringList.create;
  x:= NameList.Count-1;
  p:= 0;
  for i:=0 to x do begin
    if (NameList[p] = '') or (NameList[p] = 'Ignore') or (NameList[p] = 'FTPIgnore') or (NameList[p] = 'All') then begin
      NameList.Delete(p);
     end else begin
      inc(p);
    end
  end;
  StringGrid1.RowCount:= NameList.Count+1;
  setlength(passes, NameList.count);
  for i:=0 to NameList.Count-1 do begin
//    IniFile.ReadSectionValues(NameList[i], sec);
//    if NameList[i] <> 'All' then begin
//      if (NameList[i] <> '') and (NameList[i] <> 'Ignore') and (NameList[i] <> 'ALL') then begin
        StringGrid1.cells[0,i+1]:= IniFile.ReadString(NameList[i], 'Name', '');//  copy(sec[0],pos('=',sec[0])+1,high(integer));
        StringGrid1.cells[1,i+1]:= IniFile.ReadString(NameList[i], 'Host', '');//  copy(sec[1],pos('=',sec[1])+1,high(integer));
        StringGrid1.cells[2,i+1]:= IniFile.ReadString(NameList[i], 'Port', '');//  copy(sec[2],pos('=',sec[2])+1,high(integer));
        StringGrid1.cells[3,i+1]:= IniFile.ReadString(NameList[i], 'User', '');//  copy(sec[3],pos('=',sec[3])+1,high(integer));
        StringGrid1.cells[4,i+1]:= IniFile.ReadString(NameList[i], 'DirL'+Konf, '');//  copy(sec[4],pos('=',sec[4])+1,high(integer));
        StringGrid1.cells[5,i+1]:= IniFile.ReadString(NameList[i], 'DirF', '');//  copy(sec[5],pos('=',sec[5])+1,high(integer));
        StringGrid1.Cells[6,i+1]:= BoolToStr(IniFile.ReadBool(NameList[i], 'Ign', false), true);
        StringGrid1.Cells[7,i+1]:= BoolToStr(IniFile.ReadBool(NameList[i], 'FPage', false), true);
        StringGrid1.Cells[8,i+1]:= BoolToStr(IniFile.ReadBool(NameList[i], 'Passive', false), true);
        passes[i]:= IniFile.ReadString(NameList[i], 'Pass', '');
//      end;
//    end;
  end;
  IniFile.ReadSectionValues('Ignore', NameList);
  SetLength(FIgnoreArray, NameList.Count);
  for i:=0 to NameList.Count-1 do begin
    p:= pos('=', NameList[i]);
    FIgnoreArray[i]:= copy(NameList[i], p+1, high(integer));
  end;
  IniFile.ReadSectionValues('FTPIgnore', NameList);
  SetLength(FFTPIgnoreArray, NameList.Count);
  for i:=0 to NameList.Count-1 do begin
    p:= pos('=', NameList[i]);
    FFTPIgnoreArray[i]:= copy(NameList[i], p+1, high(integer));
  end;
  FWriteLog:= IniFile.ReadBool('All', 'Log', false);
  FJustMD5:= IniFile.ReadBool('All', 'MD5', false);
  NameList.free;
  if StringGrid1.RowCount <= 11 then begin
    UserDialog.Height:= StringGrid1.RowCount * StringGrid1.DefaultRowHeight + 35;
  end else begin
    UserDialog.Height:= 11 * StringGrid1.DefaultRowHeight + 10;
  end;
end;

procedure TUserDialog.Button1Click(Sender: TObject);
begin
  UseSelected;
end;

procedure TUserDialog.Button2Click(Sender: TObject);
begin
  InputQuery('Create New', 'Name?', FName);
  FIgno:= true;
  FFpage:= true;
  FPassive:= true;
  UserDialog.ModalResult:= 1;
end;

procedure TUserDialog.Button3Click(Sender: TObject);
var
  i: integer;
begin
  Inifile:= TIniFile.Create(FIniFileName);
  i:= StringGrid1.row;
  IniFile.EraseSection(StringGrid1.Cells[0,i]);
  buildgrid;
  iniFile.free;
end;

procedure TUserDialog.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
//  UseSelected;
end;

procedure TUserDialog.FormResize(Sender: TObject);
begin
  StringGrid1.DefaultColWidth:= (StringGrid1.Width-15)div StringGrid1.ColCount;
end;

initialization
  {$I UsrDialog.lrs}

end.

