unit myftpdirdialog;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ComCtrls,
  FTPSend, StdCtrls;

type

  { TFTPDirectoryDialog }

  TFTPDirectoryDialog = class(TForm)
    Button1: TButton;
    Button2: TButton;
    TreeView1: TTreeView;
    
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MakeList(selected: TTreeNode);
    procedure TreeView1DblClick(Sender: TObject);
  private
    FHost: string;
    FPort: string;
    FUser: string;
    FPass: string;
    FPath: string;
  //  FChange: boolean;
    { private declarations }
  public
    property Host: string read FHost write FHost;
    property Port: string read FPort write FPort;
    property User: string read FUser write Fuser;
    property Pass: string read FPass write FPass;
    property Path: string read FPath;
 //   property Change Boolean read FChange write FChange;
    
    { public declarations }
  end; 

var
  FTPDirectoryDialog: TFTPDirectoryDialog;
  AFTPSend: TFTPSend;
  dotstr: string;

implementation

{ TFTPDirectoryDialog }

procedure TFTPDirectoryDialog.FormCreate(Sender: TObject);
begin
  AFTPsend:= TFTPSend.create;
 // FChange:= true;
  TreeView1.AutoExpand:= true;
end;

procedure TFTPDirectoryDialog.FormResize(Sender: TObject);
begin
  TreeView1.Height:= self.Height - 25;
  Button1.top:= TreeView1.Height;
  Button2.top:= TreeView1.Height;
end;

procedure TFTPDirectoryDialog.Button1Click(Sender: TObject);
var
  temps1: string;
  tmp: TTreeNode;
  i: integer;
begin
  tmp:= TreeView1.Selected;
  temps1:= '';
  if assigned(tmp) then begin
    temps1:= tmp.Text;
    while assigned(tmp.Parent) do begin
      tmp:= tmp.parent;
      temps1:= tmp.text + '/' + temps1;
    end;
  end;
  fpath:= dotstr + temps1;
  ModalResult:= 1;
end;

procedure TFTPDirectoryDialog.Button2Click(Sender: TObject);
begin
  fpath:= '';
  ModalResult:= 1;
end;

procedure TFTPDirectoryDialog.FormShow(Sender: TObject);
var
  i: integer;
  dirs: string;
  curs: TCursor;
begin
  TreeView1.Items.Clear;
  dotstr:= '';
  AFTPsend.UserName:= FUser;
  AFTPsend.Password:= FPass;
  AFTPsend.TargetHost:= FHost;
  AFTPsend.TargetPort:= FPort;
  AFTPSend.Timeout:= 10000;
  FTPDirectoryDialog.Caption:= FHost + ':' + FUser;
  curs:= screen.Cursor;
  Screen.Cursor:= crHourGlass;
  if AFTPSend.login then begin
    Screen.Cursor:= curs;
    dirs:= AFTPSend.GetCurrentDir;
    while AFTPSend.ChangeWorkingDir('..') do begin
      if dirs <> AFTPSend.GetCurrentDir then begin
        dirs:= AFTPSend.GetCurrentDir;
        dotstr:= dotstr + '../';
      end else break;
    end;
    AFTPSend.List(AFTPSend.GetCurrentDir, false);
    for i:= 0 to AFTPSend.FtpList.Count-1 do begin
      if AFTPSend.FtpList[i].Directory then begin
        TreeView1.Items.Add(nil, AFTPSend.FtpList[i].FileName);
      end;
    end;
  end else begin
    Screen.Cursor:= curs;
    ShowMessage('FTP not connected');
    ModalResult:= 1;
  end;
end;

procedure TFTPDirectoryDialog.MakeList(selected: TTreeNode);
var
  i: integer;
begin
  AFTPSend.List(AFTPSend.GetCurrentDir, false);
  for i:= 0 to AFTPSend.FtpList.Count-1 do begin
    if AFTPSend.FtpList[i].Directory then begin
      TreeView1.Items.AddChild(selected, AFTPSend.FtpList[i].FileName);
    end;
  end;
end;

procedure TFTPDirectoryDialog.TreeView1DblClick(Sender: TObject);
var
  temps1: string;
  tmp: TTreeNode;
  
  procedure changedir(newdir: string);
  var
    list: TStringList;
    i, n: integer;
    tmps1, tmps2: string;
  begin
 //   result:= true;
    if newdir = fpath then exit;
    tmps1 := fpath;
    list:= TStringList.Create;
    list.Delimiter:= '/';
    if length(tmps1) > 0 then begin
      if tmps1[1] = '/' then delete(tmps1, 1, 1);
    end;
    list.DelimitedText:= tmps1;
    fpath:= newdir;
    tmps1:= '';
    n:= List.Count;
    if n > 0 then begin
      for i:= 0 to n - 1 do begin
        tmps1:=  tmps1 + '../';
      end;
      if not AFTPsend.ChangeWorkingDir(tmps1) then begin
        list.free;
//        result:= false;
        exit;
      end;
    end;
    if length(newdir) > 0 then begin
      if newdir[1] = '/' then delete(newdir, 1, 1);
    end;
    list.DelimitedText:= newdir;
    n := List.Count;
    for i := 0 to n - 1 do begin
      tmps1:= list[i];
      tmps2:= AFTPsend.GetCurrentDir;
      AFTPsend.ChangeWorkingDir(tmps1);
      tmps2:= AFTPsend.GetCurrentDir;
    end;
    list.free;
  end;
begin
  tmp:= TreeView1.Selected;
  if assigned(tmp) then begin
    temps1:= tmp.Text;
    while assigned(tmp.Parent) do begin
      tmp:= tmp.parent;
      temps1:= tmp.text + '/' + temps1;
    end;
    changedir(temps1);
    makelist(TreeView1.Selected);
  end;
end;

initialization
  {$I myftpdirdialog.lrs}

end.

